let data;

function preload() {
  data = loadTable(
    'https://gist.githubusercontent.com/vishusikka/6d90af063db9a3c714099f74c6824410/raw/549e567ee370c3932f1a313a642da844086964d8/boxplot.csv',
    'csv',
    'header'
  );
}

function setup() {
  createCanvas(1000, 1000);

  text(
    'Boxplot for all makes and models 2009-2012',
    250,
    20
  );
  textAlign(LEFT);
  push();
  let angle2 = radians(-90);
  translate(-90, 280);
  rotate(angle2);
  text('Median City MPG', -100, 250);
  pop();
  var nrows = data.getRowCount();

  var mpg = [];
  var place = 0;

  //Median.City.mpg
  for (i = 0; i < nrows; i++) {
    var transmission = data
      .getRow(i)
      .getString('Model.Year');
    mpg[place] = parseInt(
      data.getRow(i).getString('Median.City.mpg')
    );
    place++;
  }

  //Sort values
  mpg.sort(function (a, b) {
    return a - b;
  });

  //Find median value function
  const medianVal = (arr, len) => {
    const mid = Math.floor(arr.length / 2);

    if (arr.length % 2 != 0) {
      return (arr[mid - 1] + arr[mid]) / 2;
    } else {
      return arr[mid];
    }
  };

  var halfLength_mpg = Math.ceil(mpg.length / 2);

  //Set minimum value
  var minval = min(mpg);

  //Set Quartile1
  var q1 = medianVal(
    mpg.slice(0, halfLength_mpg),
    halfLength_mpg
  );

  //Set Median
  var q2 = medianVal(mpg, mpg.length);

  //Set Quartile3
  var q3 = medianVal(
    mpg.slice(halfLength_mpg, mpg.length),
    mpg.slice(halfLength_mpg, mpg.length).length
  );

  //Set maximum value
  var maxval = max(mpg);
  //print(maxval)
  var x = 690;
  var y = 405;
  var dx = 0;

  for (let i = 0; i <= maxval / 2; i++) {
    text('-', y - 190, x - dx);
    text(i * 2, y - 220, x - dx);
    dx += maxval;
  }

  rect(minval + 330, minval + 530, 50, 0);
  text(minval, minval + 380, minval + 530);
  line(360, minval + 530, 360, 410);
  rect(q1 + 360, 410, -30, q2 - q1 - 50);
  text(q1, 380, minval + 410);
  rect(375, 310, -30, (q3 - q2) / 2 + 50);
  text(q2, 380, minval + 360);
  line(360, 310, 360, 30);
  text(q3, 380, minval + 300);
  rect(maxval - 305, 100, 50, 0);
  text(maxval, 365, minval + 30);
}
